<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div :class="['custom-select-wrapper', { 'open': isDropdownOpen }]">
        <div class="custom-select-input">
            <label :for="defaultValue">{{ defaultTitle }}</label>
            <input type="text" :name="defaultValue" :id="defaultValue" v-model="selectedValue" readonly
                @click="toggleDropdown" @keydown.enter="toggleDropdown" @keydown.space.prevent="toggleDropdown"/>
        </div>

        <div class="dropdown" v-if="isDropdownOpen">
            <button class="dropdown-item" v-if="defaultOptionValue !== 'id'" v-for="(option, index) in options"
                :key="index" @click="selectOption(option?.name)">
                {{ option?.name }}
            </button>
            <button class="dropdown-item" v-if="defaultOptionValue === 'id'" v-for="(option, index) in options"
                :key="index" @click="selectOption(option)">
                {{ option?.name }}
            </button>
        </div>
    </div>
</template>

<script setup lang="ts">
const isDropdownOpen = ref(false);
const selectedValue = ref('');

const props = defineProps({
    options: Object,
    defaultTitle: String,
    defaultValue: String,
    defaultOptionValue: String
});

const emit = defineEmits(['selected']);

const toggleDropdown = () => {
    isDropdownOpen.value = !isDropdownOpen.value;
};

const selectOption = (option: any) => {
    isDropdownOpen.value = false;
    if (props.defaultOptionValue === 'id') {
        selectedValue.value = option.name;
        emit('selected', option.id);
    } else {
        selectedValue.value = option;
        emit('selected', option);
    }
};
</script>